Subject: Re: APUS and IOs question

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 07 Nov 2006 07:14:48 +1100

On Mon, 2006-11-06 at 16:18 +0100, Simon Richter wrote:
> Hi,
> 
> Benjamin Herrenschmidt wrote:
> 
> > Somebody who understands APUS around ?
> 
> I have one, but I don't understand all of it. :-)
> 
> > In include/asm-ppc/io.h, we have a special definition of the PCI IO
> > accessors readw,writew,readl and writel for APUS that don't do byteswap
> > and also don't do barriers.
> 
> APUS PCI is weird, to say the least. The PCI extension is basically
> built to accomodate a single PCI device, which happens to be a Permedia2
> graphics chip that allows byte-swapped mappings of both register and
> framebuffer space and is never told to do DMA because nobody knows what
> kind of interesting effects that would have, so the only synchronisation
> that is needed is between accesses to the framebuffer and the GPU.
> 
> That, and that the 604e+ probably doesn't reorder accesses that much
> anyway that the barriers would do any good here. :-)

Still, it annoys me to have an  APUS-specific definition of accessors
that would otherwise be common to everybody...

Anyway, I decided not to change asm-ppc/io.h, so this will only become
an issue if we ever move APUS over to arch/powerpc

Ben.